import WebFlow.*;
import WebFlow.event.*;
import WebFlow.xml.*;
import WebFlow.submitJob2.*;
import WebFlow.ATD.*;
import org.omg.CORBA.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;
import java.util.*;

public class RunAppl extends JInternalFrame {

String selectedServer;
desktop d;
JComboBox cb, acb;
Vector hosts;
JTabbedPane inputs,outputs;
JTabbedPane center;
String AD;
String application;
String ApplHost;
JPanel[] inTab, outTab;
JTextField[] inTextField, outTextField;
JTextArea cmdDisplay, stdoutTA;
int cmdDisplayLength=180;
String Applications[];
String xmlFile,xmlATDFile;
JPanel helpPanel, optionPanel, streamPanel, argPanel, envPanel;
JPanel SwPanel, ArPanel, stdoutPanel;

ORB orb;
String IorURL;
WebFlowContext master;
org.omg.CORBA.Object oxml,oatd,osj;
submitJob2 submit;
XmlServer parser;
  //XmlATD atdParser;

boolean batchJob=false;
String jobid;

  public RunAppl(desktop d) {
  super("Run Application", true, true, true, true);
  this.d = d;
  IorURL = d.IORfileURL;
  
  this.selectedServer = d.selectedServer;
  xmlFile = d.AADxml;
  xmlATDFile = d.AADroot+"ATD.xml";

  /*  
  if(Connection.ws==null) { scream! }
    connect();
  */

  JPanel bck = new JPanel();
  bck.setLayout(new BorderLayout());
  getContentPane().add(bck);
  

  JPanel upper = new JPanel();
  center = new JTabbedPane();
  JPanel lower = new JPanel();


  /* ----- upper panel ----- */
  upper.setLayout(new GridLayout(3,1));

  JPanel applPanel = new JPanel();
  JPanel hostPanel = new JPanel();
  JPanel cmdPanel = new JPanel();

  /* applPanel */

  applPanel.setLayout(new GridLayout(1,2)); 
  applPanel.add(new JLabel("select application: "));
  acb = new JComboBox();
  acb.setPreferredSize(new Dimension(200,20));
  applicationList();
  acb.addActionListener(new ActionListener(){
    public void actionPerformed(ActionEvent e) {
       setApplication((String)((JComboBox)e.getSource()).getSelectedItem());
    }
  });
  applPanel.add(acb);

  /* host panel */
  hostPanel.setLayout(new GridLayout(1,2)); 
  hostPanel.add(new JLabel("select target host: "));
  hosts=new Vector();
  cb = new JComboBox(hosts);
  cb.setPreferredSize(new Dimension(200,20));
  cb.addActionListener(new ActionListener(){
    public void actionPerformed(ActionEvent e) {
       setApplHost((String)((JComboBox)e.getSource()).getSelectedItem());
    }
  });
  hostPanel.add(cb);

  /* cmdPanel */
  cmdDisplay = new JTextArea();
  //cmdDisplay = new JTextArea("command line goes here",cmdDisplayLength,5);
  cmdDisplay.setEditable(false);
  cmdDisplay.setPreferredSize(new Dimension(cmdDisplayLength*3,20));
  cmdPanel.add(cmdDisplay);
  //cmdPanel.add(new JLabel("command goes here"));

    upper.add(applPanel); 
    upper.add(hostPanel);
    upper.add(cmdPanel);

  /*-----  end of upper pannel -----*/

  /*------ center panel ------------*/
  helpPanel = new JPanel();
  helpPanel.add(new JLabel("Help"));
  optionPanel = new JPanel();
  optionPanel.setLayout(new BorderLayout());
  optionPanel.add(new JLabel("select switches"),BorderLayout.NORTH);
  argPanel = new JPanel();
  argPanel.setLayout(new BorderLayout());
  argPanel.add(new JLabel("set arguments"),BorderLayout.NORTH);
  JPanel inPanel = new JPanel();
  JPanel outPanel = new JPanel();
  streamPanel = new JPanel();
  streamPanel.add(new JLabel("redirect streams"));
  envPanel = new JPanel();
  envPanel.add(new JLabel("set environmental variables"));
  stdoutPanel = new JPanel();
  stdoutPanel.setLayout(new BorderLayout());
  stdoutPanel.add(new JLabel("standard output"),BorderLayout.NORTH);
  stdoutTA = new JTextArea(30,6);
  stdoutTA.setFont(new Font("Courier",Font.PLAIN,12));
  JScrollPane scroller = new JScrollPane(stdoutTA,JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
  stdoutPanel.add(scroller,BorderLayout.CENTER);

  /* inPanel */
  inputs = new JTabbedPane();
  inPanel.add(inputs);

  /* outPanel */ 

  outputs = new JTabbedPane(); 
  outPanel.add(outputs);

  center.addTab("Help",helpPanel);
  center.addTab("options",optionPanel);
  center.addTab("arguments",argPanel);
  center.addTab("inputFiles",inPanel);
  center.addTab("outputFiles",outPanel);
  center.addTab("streams",streamPanel);
  center.addTab("environment",envPanel);
  center.addTab("stdout",stdoutPanel);

  /* ----- end of center panel ------*/
  
  /* ------ lower panel -------------*/
  JButton runB = new JButton("submit job");
  runB.addActionListener(new ActionListener() {
       public void actionPerformed(ActionEvent e) {
         submitJob();
       }
     });
  lower.add(runB);
  /* ------ end of lower panel--------*/

  bck.add(upper, BorderLayout.NORTH);
  bck.add(center, BorderLayout.CENTER);
  bck.add(lower, BorderLayout.SOUTH);

  }

  public void submitJob() {

      String runCommand="";

      if(parser.instantiateParser(xmlFile)) {

      System.out.println("submit job");
      
      /* command line */

      System.out.println("CommandLine=");
      runCommand=cmdDisplay.getText();
      System.out.println(runCommand);
      parser.addRunCommand(application,ApplHost,runCommand);     

      /* input files */

      System.out.println("input files");
      int n=inputs.getTabCount();
      if(n<1) {
        System.out.println("no input files defined");
      }
      else {
        System.out.println(n+" file(s) defined");
        JTextField jtf=null;
        String inFile="";
        for(int j=0; j<n; j++) {
          JPanel p = (JPanel)inputs.getComponentAt(j);
          int m = p.getComponentCount();
          for (int i=0; i<m; i++) {
            Component c = p.getComponent(i);
            if(c instanceof JTextField) jtf = (JTextField)c;
            if(c instanceof JLabel) inFile=((JLabel)c).getText();
	  }
          System.out.println("inFile: "+inFile);
          System.out.println("selected: "+jtf.getText());
          String[] sourceDesc = new String[3];
          sourceDesc[0]="osprey4.npac.syr.edu";
          sourceDesc[1]="/tmp";
          sourceDesc[2]=jtf.getText();
          parser.addIPSource(application,ApplHost,inFile,sourceDesc);
	}
      }

      /* output files */

      System.out.println("output files");
      n=outputs.getTabCount();
      if(n<1) {
        System.out.println("no output files defined");
      }
      else {
        System.out.println(n+" file(s) defined");
        JTextField jtf=null;
        String outFile="";
        for(int j=0; j<n; j++) {
          JPanel p = (JPanel)outputs.getComponentAt(j);
          int m = p.getComponentCount();
          for (int i=0; i<m; i++) {
            Component c = p.getComponent(i);
            if(c instanceof JTextField) jtf = (JTextField)c;
            if(c instanceof JLabel) outFile=((JLabel)c).getText();
	  }
          System.out.println("outFile: "+outFile);
          System.out.println("selected: "+jtf.getText());
          String[] destDesc = new String[3];
          destDesc[0]="osprey4.npac.syr.edu";
          destDesc[1]="/tmp";
          destDesc[2]=jtf.getText();
          parser.addOPSource(application,ApplHost,outFile,destDesc);
	}
      }


        AD = d.AADroot+application+".xml";
        if(parser.createAD(application,ApplHost)) {
          if(parser.SaveAsXml(AD)) {
            System.out.println("sucess!");
	  }
          else System.out.println("SaveAsXML failed");
	}
        else System.out.println("createAD failed");
      }
      else System.out.println("instantiateParser failed");

      /*
      // create ATD 
      if(atdParser.newATD(xmlATDFile)) {
        atdParser.addApplication(AD);
        atdParser.SaveAsXML();
      }
      else {
       System.out.println("creating ATD failed :-(");
      }

      // just test if I can parse the newly generated ATD.xml 
      if(atdParser.instantiateParser(xmlATDFile)) {
         String[] appl = atdParser.getApplications();
         for(int i=0; i<appl.length; i++) {
           System.out.println(i+". "+appl[i]);
	 }
        String[] conn = atdParser.getConnections();
         for(int i=0; i<conn.length; i++) {
           System.out.println(i+". "+conn[i]);
	 }
      }
      else {
       System.out.println("reading ATD failed :-(");
      }
      */
     center.setSelectedComponent(stdoutPanel);

     /* how to submit the job? */
     System.out.println("application host: "+ApplHost);
     if(runCommand.indexOf("qsub")>-1) batchJob=true;
     else batchJob=false;
     jobid="0";

     if(ApplHost.equals(d.RootHost)) {
        submit.submitLocally(runCommand);
     }
     else {
        submit.submitRsh(ApplHost,"pse",runCommand);
     }  
     System.out.println("run locally completed");
     String OLine="";
     stdoutTA.setText(OLine);
     int curLine=0; 
     System.out.println("start reading...");
     while(!OLine.equals("theEnd")) {
       OLine=submit.getOLine(curLine);
       if(OLine.equals("wait")) {
          System.out.println("waiting...");
          waitFor(10);
       }
       else {
	   //System.out.println(curLine+" "+OLine);
          stdoutTA.append(OLine+"\n");
          if(batchJob) {
             //extract job id
            int id1=OLine.indexOf("<");
            int id2=OLine.indexOf(">");
            if(id1>-1) {
	      if(id2>-1) {
                 jobid=OLine.substring(id1+1,id2);
                 id1=jobid.indexOf(".");
                 jobid=jobid.substring(0,id1);
                 System.out.println("JobId is "+jobid); 
	      }
            }
	  }
          submit.setLineRead(curLine);
          curLine++;
          if(curLine==20) curLine=0;
       }  
     }
     if(batchJob) {
       BatchJobStatus bjs = new BatchJobStatus(jobid,ApplHost,"pse",d,submit);
       Thread bjsThread = new Thread(bjs);
       bjsThread.start();
     }
  }

  public void applicationList() {
    System.out.println("try to instantiate parser with "+xmlFile);
    if(parser.instantiateParser(xmlFile)) {
       Applications=parser.getApplications();
    }
    for(int i=0; i<Applications.length; i++) {
       acb.addItem(Applications[i]);
    }
    acb.setSelectedIndex(0);
  } 

  public void setApplication(String s){
    application = s;
    updateHosts();
  } 

  public void setApplHost(String s){
    String cmd,cmdLine;
    ApplHost = s;
    System.out.println("Selected host: "+ApplHost);
    System.out.println(xmlFile);
    System.out.println(application);
    if(parser.instantiateParser(xmlFile)) {
      String exec = parser.getExec(application,ApplHost);
      String[] arguments = parser.getArguments(application,ApplHost); 
      String[] switches = parser.getSwitches(application,ApplHost);
      String[] NameValue = parser.getNameValue(application,ApplHost);
      cmdLine = exec;

        if(SwPanel != null) SwPanel.removeAll();
        else SwPanel = new JPanel();

        if(!switches[0].equals("null")) {
        int nSwitches = switches.length;
        if(nSwitches < 10) {
           SwPanel.setLayout(new GridLayout(nSwitches,2));
	}
        else {
           SwPanel.setLayout(new GridLayout((nSwitches+1)/2,4));
	}
        String thisSwitch,thisValue,thisSpace,thisMult;  
        boolean msfixed,mfixed,literal,v;
        for(int i=0; i<nSwitches; i++) {
          thisSwitch="";
          thisValue="";
          thisSpace="";
          thisMult="";
          msfixed=false;
          mfixed=false;
          v=false;
          literal=true;
          System.out.println(switches[i]);
          StringTokenizer st = new StringTokenizer(switches[i]);
          while(st.hasMoreTokens()) {
           String nextToken = st.nextToken();
           int l = nextToken.length();
           if(nextToken.equals("[msfixed]")) msfixed=true;
           else {
            if(nextToken.equals("[msquestion]")) msfixed=false;
            else { 
             if (nextToken.equals("[mfixed]")) mfixed=true;
             else {
	      if(nextToken.startsWith("[m")) {
                thisMult=nextToken.substring(2,l-1);
	      }
     	      else {
		if(nextToken.startsWith("[s")) {
                 if(nextToken.indexOf("none")>-1) thisSpace=""; 
                 if(nextToken.indexOf("space")>-1) thisSpace=" "; 
                 if(nextToken.indexOf("equals")>-1) thisSpace="="; 
                }
		 else {
                   if(nextToken.startsWith("[v")) {
                      thisValue = nextToken.substring(2,l-1);
                      v=true; 
		   }
		   else {
                     if(nextToken.startsWith("[t")) {
                        if(nextToken.equals("[tliteral]")) literal=true;
                        else literal=false;
		     }
                     else {
                       thisSwitch = nextToken;
		     }
		   }
		 }
	      }
	     }
	    }
	   }
	  } //while

	  if(msfixed) {
             cmdLine += " "+thisSwitch;
             if(v) {
              cmdLine += thisSpace+thisValue;
              if(!literal){
                 System.out.println("msfixed: addTab"); 
                 JPanel swInFile = new JPanel();
                 swInFile.setLayout(new GridLayout(2,1));
                 thisSwitch +=thisSpace+thisValue;
                 swInFile.add(new JLabel("switch: "+thisSwitch));
                 JTextField swInFileTF = new JTextField(30);
                 swInFile.add(swInFileTF);
                 swInFile.setPreferredSize(new Dimension(500,50));
                 inputs.addTab(thisSwitch,swInFile);
	      }
	     }
	  } 
          else {
            if(v) {
              thisSwitch += thisSpace+thisValue;
              if(!literal){
                 JCheckBox cb = new JCheckBox(thisSwitch);
                 cb.addItemListener(new ItemListener() {
	           public void itemStateChanged(ItemEvent ev) {
                     JCheckBox src=(JCheckBox)ev.getSource();
                     String what=src.getText();
                     checkBoxChange1(ev.getStateChange(),what);
	           }
	         });
                 SwPanel.add(cb);
	      }
	    }
            else {
                 JCheckBox cb = new JCheckBox(thisSwitch);
                 cb.addItemListener(new ItemListener() {
	           public void itemStateChanged(ItemEvent ev) {
                     JCheckBox src=(JCheckBox)ev.getSource();
                     String what=src.getText();
                     checkBoxChange(ev.getStateChange(),what);
	           }
	         });
                 SwPanel.add(cb);
	    }
	  }
	} //for 
      optionPanel.add(SwPanel,BorderLayout.CENTER);  
      }

      if(!NameValue[0].equals("null")) {
        for(int i=0; i<NameValue.length; i++) {
          cmdLine += " "+NameValue[i];
	}  
      } 

        if(ArPanel != null) ArPanel.removeAll();
        else ArPanel = new JPanel();

      if(!arguments[0].equals("null")) {
        int nArguments = arguments.length;
        if(nArguments < 10) {
           ArPanel.setLayout(new GridLayout(nArguments,2));
	}
        else {
           ArPanel.setLayout(new GridLayout((nArguments+1)/2,4));
	}
        String thisArgument,thisMult;
        boolean mfixed,literal;  
        for(int i=0; i<nArguments; i++) {
          thisArgument="";
          thisMult="";
          mfixed=false;
          literal=true;
          System.out.println(arguments[i]);
          StringTokenizer st = new StringTokenizer(arguments[i]);
          while(st.hasMoreTokens()) {
            String nextToken=st.nextToken();
            int l = nextToken.length();
            if(nextToken.startsWith("[m")) { 
               if(nextToken.equals("[mfixed]")) mfixed=true;
               thisMult=nextToken.substring(2,l-1);
            }
            else {
		if(nextToken.startsWith("[t")) {
                  if(nextToken.equals("[tliteral]")) literal=true;
                  else literal=false;
		}
		else {
                  thisArgument=nextToken;
		}
	    }
	  }//while

	  if(mfixed) {
             cmdLine += " "+thisArgument;
	     if(!literal) {
               JPanel argInFile = new JPanel();
               argInFile.setLayout(new GridLayout(2,1));
               argInFile.add(new JLabel("argument: "+thisArgument));
               JTextField argInFileTF = new JTextField(30);
               argInFile.add(argInFileTF);
               argInFile.setPreferredSize(new Dimension(500,50));
               inputs.addTab(thisArgument,argInFile);
	     }
          }
          else {
              JCheckBox cb_arg  = new JCheckBox(thisArgument);
                cb_arg.addItemListener(new ItemListener() {
	             public void itemStateChanged(ItemEvent ev) {
                     JCheckBox src=(JCheckBox)ev.getSource();
                     String what=src.getText();
                     checkBoxChange1(ev.getStateChange(),what);
	          }
	        });
                ArPanel.add(cb_arg);
	  }
        argPanel.add(ArPanel,BorderLayout.CENTER);  
	}  
      }
      cmdDisplay.setText(cmdLine);
      /*
      System.out.println(cmdLine.length()+" "+cmdDisplayLength);
      if(cmdLine.length() <= cmdDisplayLength) {
           cmdDisplay.setText(cmdLine);
      }
      else {
       String firstLine=cmdLine.substring(0,cmdDisplayLength);
       cmdDisplay.setText(firstLine);
       cmdLine=cmdLine.substring(cmdDisplayLength);
       while(cmdLine.length()>cmdDisplayLength) {
         cmdDisplay.append("\n"+cmdLine.substring(0,cmdDisplayLength));
         cmdLine = cmdLine.substring(cmdDisplayLength);
       }
       cmdDisplay.append("\n"+cmdLine);
      }
      */
    }
    getInputs();
  } 


  public void updateHosts(){
    String[] hostList = null;
    hosts.removeAllElements();
    inputs.removeAll();
    outputs.removeAll();
    if(parser.instantiateParser(xmlFile)) {
      hostList = parser.getInstalledHosts(application);
    }
    try {
       for(int i=0; i<hostList.length; i++) {
       hosts.addElement(hostList[i]);
       }
    }
    catch (Exception e) {
        System.out.println("no installed hosts");
        hosts.addElement("not installed");
    }
    cb.setSelectedIndex(0);
    this.show();
  }


  public void getInputs() {
    if(parser.instantiateParser(xmlFile)) {
      String[] inputfiles = parser.getIPFiles(application,ApplHost);
      String[] outputfiles = parser.getOPFiles(application,ApplHost);
      if((inputfiles != null) && (inputfiles.length>0)) {
        int nfiles = inputfiles.length/2;
        inTab = new JPanel[nfiles];
        inTextField = new JTextField[nfiles]; 
           for(int i=0; i<(inputfiles.length); i=i+2) {
            int k = i/2;
            inTab[k] = new JPanel();
            inTab[k].setLayout(new GridLayout(2,1));
            inTab[k].add(new JLabel(inputfiles[i]+inputfiles[i+1]));
            inTextField[k]= new JTextField(30);
            inTab[k].add(inTextField[k]);
            inTab[k].setPreferredSize(new Dimension(500,50));
            inputs.addTab("input file "+k,inTab[k]);
	   }
      }
      if((outputfiles != null) && (outputfiles.length>0)) {
        int nfiles = outputfiles.length/2;
        outTab = new JPanel[nfiles];
        outTextField = new JTextField[nfiles]; 
           for(int i=0; i<(outputfiles.length); i=i+2) {
            int k = i/2;
            outTab[k] = new JPanel();
            outTab[k].setLayout(new GridLayout(2,1));
            outTab[k].add(new JLabel(outputfiles[i]+outputfiles[i+1]));
            outTextField[k]= new JTextField(30);
            outTab[k].add(outTextField[k]);
            outTab[k].setPreferredSize(new Dimension(500,50));
            outputs.addTab("output file "+i,outTab[k]);
	   }
      }
               
    }
  }

   public synchronized void waitFor(long howLong){
     try {
        wait(howLong);
     } catch (Exception e) { System.out.println(e);}
   }

  public void checkBoxChange(int i, String what) {
    if(i==ItemEvent.DESELECTED) {
       String copy = cmdDisplay.getText();
       int idx = copy.indexOf(what);
       String newText = copy.substring(0,idx-1);
       newText += copy.substring(idx+what.length());
       cmdDisplay.setText(newText);
    }
    if(i==ItemEvent.SELECTED) {
      cmdDisplay.append(" "+what);
   }
  }

  public void checkBoxChange1(int i, String what) {
    if(i==ItemEvent.DESELECTED) {
       String copy = cmdDisplay.getText();
       int idx = copy.indexOf(what);
       String newText = copy.substring(0,idx-1);
       newText += copy.substring(idx+what.length());
       cmdDisplay.setText(newText);
  
       int k = inputs.indexOfTab(what);     
       inputs.removeTabAt(k); 

    }
    if(i==ItemEvent.SELECTED) {
      cmdDisplay.append(" "+what);

      JPanel swInFile = new JPanel();
      swInFile.setLayout(new GridLayout(2,1));
      swInFile.add(new JLabel(what));
      JTextField swInFileTF = new JTextField(30);
      swInFile.add(swInFileTF);
      swInFile.setPreferredSize(new Dimension(500,50));
      inputs.addTab(what,swInFile);
   }
  }
}


