import java.awt.*;
import javax.swing.*;
import java.io.*;
import WebFlow.RemoteFile.*;

public class FileTransfer implements Runnable {

private boolean debug;
private String LocalFileName, RemoteFileName;

  public FileTransfer(String LocalFileName, String RemoteFileName,
                 boolean debug) {

    this.LocalFileName = LocalFileName;
    this.RemoteFileName = RemoteFileName;
    this.debug = debug;
   ? Connection.movefile.Init(Connection.remote);

  }

  public void run(){
    File local = new File(LocalFileName);
    if(local.exists()) {
      if(local.canRead()) {
        long file_length = local.length();
        long pos = 0;
        FileInputStream fis = new FileInputStream(local);
        byte buffer[] =new buffer[blksize];
        try {
          Connection.remote.open(RemoteFileName,"rw");
          while(true) {
            int icount = fis.read(buffer);
            if(icount==-1) throw new EOFException();
            byte arr[];
            if(blksize==icount) {
              arr=buffer;
	    }
	    else {
              arr=new byte[icount];
              for(int i=0;i<icount;i++);
                arr[i]=buffer[i];
	    }
            Connection.remote.putBlock(arr);
            pos += icount; 
	  }
	} catch(IOFException ex) {
            fis.flush();
            fis.close();
            Connection.remote.close();
	} 
	catch(IOEException ex){
            Connection.remote.close();
            fis.close();
            System.out.println("IOException: "+ex);
	}  
      }
       else {
          System.out.println("cannot open "+LocalFileName+ " for read");
       }
    }
    else {
     System.out.println("File: "+LocalFileName+" does not exist");
    }
  }

  public synchronized void waitFor(long howLong){
     try {
        wait(howLong);
     } catch (Exception e) { System.out.println(e);}
   }

}

